import numpy as np
from PIL import Image
import pickle
import cv2 as cv
import os

CASCADES_PATH = "/data/haarcascade_frontalface_default.xml"
BASE_DIR = os.path.dirname(os.path.abspath(__file__))

image_dir = os.path.join(BASE_DIR, "images")
print(BASE_DIR + CASCADES_PATH)
face_cascade = cv.CascadeClassifier(BASE_DIR + CASCADES_PATH)
recognizer = cv.face.LBPHFaceRecognizer_create()
current_id = 0
label_ids = {}
y_labels = []
x_train = []
for root, dirs, files in os.walk(image_dir):
    for file in files:
        _, ext = os.path.splitext(file)
        if ext in [".png", ".jpg", ".jfif"]:
            path = os.path.join(root, file)
            label = os.path.basename(root).lower()

            if not label in label_ids:
                label_ids[label] = current_id
                current_id += 1
            id = label_ids[label]
            print(label_ids)
            pil_image = Image.open(path).convert("L")
            image_array = np.array(pil_image, "uint8")
            faces = face_cascade.detectMultiScale(image_array, 1.5, 5)
            for (x, y, w, h) in faces:
                roi = image_array[y : y + h, x : x + w]
                x_train.append(roi)
                y_labels.append(id)

with open("labels.pickle", "wb") as f:
    pickle.dump(label_ids, f)
recognizer.train(x_train, np.array(y_labels))
recognizer.save("trainer.yml")

# import recognize_faces

# uncomment above to run trainer and recognizer in one step